#include <stdlib.h> 
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>

#define fr2fi fr2fi_
#define mosstranscounts mosstranscounts_

#define frand() ((double)random()/(RAND_MAX+1.))

#define maxn 1024

extern struct fr2fi{
    float thfk[8*maxn],simul[8*maxn];            
} fr2fi;

void mosstrans_counts(int *icase, int *achannel, float *acountrate, float *adeadtime, 
          float *sweepfr, int *counts, float *aprint, int *iseed) 
{ 
  float rf,lamqu,lambda,deadtime,sweepfrequency,ploss,lastevent,eventtime,
        cputime,mtime,prtfr, *theo;
  double carlonu,totaltime,printmct,bg_fraction,dwelltime; 
  int  nu_channel;
  long int ichannel,i,ii,j,jch,icall,iloss,icount, *isimul; 
  time_t  t0, t1; /* time_t is defined on <time.h> and <sys/types.h> as long */
  clock_t c0, c1; /* clock_t is defined on <time.h> and <sys/types.h> as int */

    srandom(*iseed);
    nu_channel=*achannel;
    sweepfrequency=*sweepfr;

    theo=   malloc(nu_channel * sizeof(float));
    isimul= malloc(nu_channel * sizeof(long int));
    for(i=0;i<nu_channel; i++) isimul[i]=0;
    for(i=0;i<nu_channel; i++) theo[i]=fr2fi.thfk[i];
    lamqu=0.0;for(i=0;i<nu_channel; i++) lamqu=lamqu+theo[i];
    lamqu=lamqu/(float)nu_channel;

    printf (" lamqu=%8.3f\n",lamqu); 
    
    t0 = time(NULL);
    c0 = clock(); 
    cputime=0.;

    prtfr=*aprint;
    lambda=*acountrate;
    deadtime=*adeadtime;
    dwelltime=1./sweepfrequency/nu_channel;
    printmct=*counts/prtfr;

    ii=1;
    iloss=0; icount=0;
    icall=0; totaltime=0.;
    ichannel=0;
    lastevent=deadtime;


    if(*icase == 3){
      while(isimul[0] < *counts){

       eventtime=-log(1.-frand())/lambda/theo[ichannel]; icall++;
       lastevent=lastevent+eventtime;
       if(lastevent > deadtime){
        isimul[ichannel]++; lastevent=0.0; icount++;
       }else{iloss++;}

       totaltime=totaltime+eventtime;
       ichannel= totaltime/dwelltime;
       i=ichannel/nu_channel; ichannel=ichannel-i*nu_channel;

       if( printmct<isimul[0]){ii=ii+1;
        printmct=*counts/prtfr*(float)ii;
        printf (" total time units:%8.0f    MC-calls=%d\n",totaltime,icall);}
      }
    }else{

       while(isimul[0] < *counts){
	 rf=frand();
       eventtime=-log(1.-rf)/lambda/theo[ichannel]; icall++;

       //jch=ichannel+eventtime/dwelltime/2.0;
       //j=jch/nu_channel; jch=jch-j*nu_channel;
       //mtime=-log(1.-frand())/lambda/theo[jch]; icall++;
       //if(mtime<eventtime)eventtime=mtime;
       //jch=ichannel+eventtime/dwelltime;
       //j=jch/nu_channel; jch=jch-j*nu_channel;

       if(frand()<theo[ichannel]){
         lastevent=lastevent+eventtime;
         if(lastevent > deadtime){
	  isimul[ichannel]++; lastevent=0.0; icount++;
	 }else{iloss++;}
       }
       eventtime=-log(1.-rf)/lambda;
        totaltime=totaltime+eventtime;
        ichannel= totaltime/dwelltime;
        i=ichannel/nu_channel; ichannel=ichannel-i*nu_channel;
       
       if( printmct<isimul[0]){ii=ii+1;
        printmct=*counts/prtfr*(float)ii;
        printf (" total time units:%8.0f    MC-calls=%d\n",totaltime,icall);}
      }
    }
      
    ploss=(float)iloss/(float)icount;
    printf (" count loss\% :%6.2f    total counts=%d\n",ploss,icount);
        c1 = clock();
        cputime=(float) (c1 - c0)/CLOCKS_PER_SEC;
        printf ("total time units:%8.0f     MC-calls=%d\n",totaltime,icall);

    for(i=0;i<nu_channel; i++) fr2fi.simul[i]=isimul[i];
    free( isimul);
    free(theo);              
}


void mosstranscounts(int *icase, int *achannel, float *acountrate, float *adeadtime, 
          float *sweepfr, int *counts, float *aprint, int *iseed) 
{ 
  float rf,lamqu,lambda,deadtime,sweepfrequency,ploss,lastevent,eventtime,
        cputime,mtime,prtfr, *theo;
  double carlonu,totaltime,printmct,bg_fraction,dwelltime; 
  int  nu_channel;
  long int ichannel,i,ii,j,jch,icall,iloss,icount, *isimul; 
  time_t  t0, t1; /* time_t is defined on <time.h> and <sys/types.h> as long */
  clock_t c0, c1; /* clock_t is defined on <time.h> and <sys/types.h> as int */

    srandom(*iseed);
    nu_channel=*achannel;
    theo=   malloc(nu_channel * sizeof(float));
    sweepfrequency=*sweepfr;

    isimul= malloc(nu_channel * sizeof(long int));
    for(i=0;i<nu_channel; i++) isimul[i]=0;
    for(i=0;i<nu_channel; i++) theo[i]=fr2fi.thfk[i];
    lamqu=0.0;for(i=0;i<nu_channel; i++) lamqu=lamqu+theo[i];
    lamqu=lamqu/(float)nu_channel;

    printf (" lamqu=%8.3f\n",lamqu); 
    
    t0 = time(NULL);
    c0 = clock(); 
    cputime=0.;

    dwelltime=1./sweepfrequency/nu_channel;

    prtfr=*aprint;
    lambda=*acountrate;
    deadtime=*adeadtime;
    printmct=*counts/prtfr;

    ii=1;
    iloss=0; icount=0;
    icall=0; totaltime=0.;
    ichannel=0;
    lastevent=deadtime;
    eventtime=0.0;

    if(*icase == 3){
      while(isimul[0] < *counts){

       eventtime=-log(1.-frand())/lambda/theo[ichannel]; icall++;
       lastevent=lastevent+eventtime;

       if(lastevent > deadtime){
        isimul[ichannel]++; lastevent=0.0; icount++;
       }else{iloss++;}

       totaltime=totaltime+eventtime;
       ichannel= totaltime/dwelltime;
       i=ichannel/nu_channel; ichannel=ichannel-i*nu_channel;

       if( printmct<isimul[0]){ii=ii+1;
        printmct=*counts/prtfr*(float)ii;
        printf (" total time units:%8.0f    MC-calls=%d\n",totaltime,icall);}
      }
    }else{

       while(isimul[0] < *counts){
       step:
       eventtime=-log(1.-frand())/lambda; icall++;
       // of source
       jch=ichannel;
       totaltime=totaltime+eventtime;
       lastevent=lastevent+eventtime;
       ichannel= totaltime/dwelltime;
       i=ichannel/nu_channel; ichannel=ichannel-i*nu_channel;
       if(frand()>theo[jch]){goto step;}

       if(lastevent > deadtime){
        isimul[jch]++; lastevent=0.0;  icount++;
       }else{iloss++;}

       if( printmct<isimul[0]){ii=ii+1;
        printmct=*counts/prtfr*(float)ii;
        printf (" total time units:%8.0f    MC-calls=%d\n",totaltime,icall);}
      }
    }
      
    ploss=(float)iloss/(float)icount;
    printf (" count loss\% :%6.2f    total counts=%d\n",ploss,icount);
        c1 = clock();
        cputime=(float) (c1 - c0)/CLOCKS_PER_SEC;
        printf ("total time units:%8.0f     MC-calls=%d\n",totaltime,icall);

    for(i=0;i<nu_channel; i++) fr2fi.simul[i]=isimul[i];
    free( isimul);
    free(theo);              
}

