    subroutine hintJgJeRELAX2(itr,icase,r_QUDI,amueg,amuee,QgdQe,cTms,je,jg,jge,  &
                     shift12,pop1,fsx1,fsx2,rate,hv1,efg1,hv2,efg2,Eagd,VV)
!     ------------------------half integral spin----------------       
!   Relaxation between 2 states  (ks=2)
!   hint: half integral spin : 2*j+1 => j+1

    implicit none 
    integer, parameter:: ks=2
    integer, intent(in):: itr,icase,jg,je,jge
    real,    intent(in):: r_QUDI,amueg,amuee,QgdQe,cTms,shift12,pop1,fsx1,fsx2,rate
    complex, intent(in):: hv1(-1:1),efg1(-2:2),hv2(-1:1),efg2(-2:2)

    complex, intent(out):: Eagd(jge*ks)
    complex, intent(out):: VV(-1:1,-1:1,jge*ks)
    complex, dimension(-1:1,-1:1,jge*ks):: V2
    complex, dimension(-2:2,jge*ks):: V2D

    real,    dimension(-je:je,-1:1,-jg:jg):: Vje_1_jg              
    real,    dimension(-je:je,-2:2,-jg:jg):: Vje_2_jg 
    real,    dimension(-jg:jg):: wpjg
    real,    dimension(-je:je):: wpje
    complex, dimension(-1:1):: hv
    complex, dimension(-2:2):: efgm

                                                                
    real(kind=8):: DOUT
    complex(kind=8),dimension(jge,jge,ks):: HXs
    complex(kind=8),dimension(jge*ks,jge*ks):: VL,VR,HXab !,AA,BB,CC
    complex, dimension(je+1,je+1) :: hame
    complex, dimension(jg+1,jg+1) :: hamg
    complex, dimension(jge,jge,jge*ks) :: RLab
!   unit matrices (Kronecker symbol)
    real, dimension(je+1,je+1):: dee
    real, dimension(jg+1,jg+1):: dgg
    real, dimension(ks,ks)    :: dab
    real, dimension(ks)       :: pop
!   wab calculated from pop1 and w12 (wab is added to a complex matrix)
    complex, dimension(ks,ks):: wab
!   indices transformations
    integer, dimension(je+1,jg+1):: iq
    integer, dimension(je+1,jg+1,ks):: iab

    complex  :: C20,C2m1,C2m2,H10,H1m1,h1c,v1mj,v2mj 
    real     :: Qjg,Qje,sq2,sq3d8,hmag,h,hi2im1,q20,q21,q22,delta2,r_delta2
    integer  i,k,kn,l,m,n,j,jm,me,mg,nrot,M1,M2,ji,ml,nstate,iqmj,iabmjn
    complex, parameter:: C0=cmplx(0.,0.), Ci=cmplx(0.,1.)

    complex, dimension(:,:), allocatable :: hm  
    jm=je
    if(jg.gt.jm) jm=jg
    allocate(hm(-jm:jm,-jm:jm))

    dOUT=10000.d1
    pop(1)=pop1; pop(2)=1.-pop1
    if(pop1.ge.1.0)then
     wab=0.
    else
!    w12=t_rate*pop2; w21=t_rate*pop1;  t_rate=w12+w21 => pop1*w12=pop2*w21
     wab(1,2)=cmplx(0.,rate*pop(2)); wab(2,1)=cmplx(0.,rate*pop(1))
     wab(1,1)=-wab(1,2);  wab(2,2)=-wab(2,1)
    end if
     
!   intensity of site i is multiplied by the Lamb-Mossbauer factor fsxi of site i
!   fxx of the crystal is the same for both sites    
    pop(1)=pop(1)*fsx1;    pop(2)=pop(2)*fsx2;

!      write(6,'(a,6f10.2,/,a,10f8.2)')'  hv=',hv,'efgm=',efgm         
!      magnetic energy                                                  
!      E(B)= - mue*(Bx*Ix+By*Iy+Bz*Iz)/I                                
!              (largest moment is mue - not mue*I(=3/2)-)               
!          = - mue*(Bz*Iz-B(+1)/sq2*I(-) + B(-1)/sq2*I(+))/I            
!      electric energy                                                  
!      E(Vik)= 3/4 eQ /I(2I-1) * Sum;ik Vik*Ii*Ik                       
!              Sum;k q2k*C2-k*(-1)**k                                   
!                                                                       
!      Abragam and Bleaney chapter 17 ,p. 680                           
!              q20=eQ/I(2I-1)*1/2*(3*Iz*Iz-I(I+1))                      
!              q21=-eQ/I(2I-1)*(Iz*(I+) + (I+)*Iz)sqrt(3/8)             
!             q2-1= eQ/I(2I-1)*(Iz*(I-) + (I-)*Iz)sqrt(3/8)             
!              q22= eQ/I(2I-1)*(I+)**2*sqrt(3/8)                        
!             q2-2= eQ/I(2I-1)*(I-)**2*sqrt(3/8)                        
!              C20= 1/2*Vzz                                             
!              C21=-2/3*(Vxz+iVyz)*sqrt(3/8)                            
!             C2-1= 2/3*(Vxz-iVyz)*sqrt(3/8)                            
!              C22= (Vxx-Vyy+2iVxy)*sqrt(3/8)/3                         
!             C2-2= (Vxx-Vyy-2iVxy)*sqrt(3/8)/3                         
!     the potential V= -e/|r-R| of a negative charge -e ( e=|e|)        
                                                                        
!     exited state                                                      
      call symbol3j(.false.,je,jg,Vje_1_jg,Vje_2_jg,wpje,wpjg) 

      sq3d8=sqrt(3./8.) 
      sq2=sqrt(2.) 
      if(QgdQe.gt.9999)then 
        Qjg=1. 
        Qje=0. 
      else 
        Qjg=QgdQe 
        Qje=1. 
      end if 

      dab=0.
      do j=1,2
       dab(j,j)=1.
      end do

      dgg=0.
      do j=1,jg+1
       dgg(j,j)=1.
      end do

      dee=0.
      do j=1,je+1
       dee(j,j)=1.
      end do

     m=0
      do i=1,jg+1
       do l=1,je+1
        m=m+1
        iq(l,i)=m
       end do
      end do

      m=0
     do k=1,2
      do i=1,jg+1
       do l=1,je+1
        m=m+1
        iab(l,i,k)=m
       end do
      end do
     end do

     nstate=0
 1111 continue
      nstate=nstate+1
      if(nstate.eq.1) then
       hv=hv1; efgm=efg1
      else if(nstate.eq.2) then
       hv=hv2; efgm=efg2
      end if

       j=je 
       hm=C0                                                                
                                                                        
       hmag=amuee/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       if(j.gt.1) then 
        hI2IM1=float(j*(2*j-2))/4. 
        C20=efgm(0)/hI2IM1*Qje 
        C2m1=efgm(-1)/hI2IM1*Qje 
        C2m2=efgm(-2)/hI2IM1*Qje 
        h=float(j*(j+2)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/8. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                        
        do m=j-2,-j,-2              !  m+1= (m+2 + m)/2 
         q21=-float(m+1)*wpje(m)*sq3d8 
         hm(m+2,m)= -C2m1*q21 + H1m1*wpje(m)*sq2 
        end do 
       else 
         hm(1,1)= H10 
         hm(-1,-1)= -H10 
         hm(1,-1)=H1m1*sq2 
       end if 
                                                                        
       if(j.ge.2) then 
        do m=j-4,-j,-2 
         q22=wpje(m+2)*wpje(m)*sq3d8 
         hm(m+4,m)= C2m2*q22 
        end do 
       end if 

       do m=-j,j,2
        do n=m+2,j,2
         hm(m,n)=conjg(hm(n,m))
        end do            
       end do
       do m=1,j+1
        do n=1,j+1
         hame(m,n)=hm(-j-2+2*n,-j-2+2*m)
        end do            
       end do            
!      do m=1,je+1                                                      
!       write(6,'(8g12.4)') (ham(m,n,nstate),n=1,je+1)
!      end do 
      
!      ground state
       j=jg
       hm=C0 
                                                                      
       hmag=amueg/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                      
       if(j.gt.1) then 
        hI2IM1=float(j*(j-1))/2. 
        C20=efgm(0)/hI2IM1*Qjg 
        C2m1=efgm(-1)/hI2IM1*Qjg 
        C2m2=efgm(-2)/hI2IM1*Qjg 
        h=float(j*(j+2)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/8. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                      
        do m=j-2,-j,-2         !  m+1= (m+2 + m)/2     
         q21=-float(m+1)*wpjg(m)*sq3d8 
         hm(m+2,m)= -C2m1*q21 + H1m1*wpjg(m)*sq2 
        end do 
       else 
         hm(1,1)= H10 
         hm(-1,-1)= -H10 
         hm(1,-1)=H1m1*sq2 
       end if 
                                                                      
       if(j.ge.2) then 
         do m=j-4,-j,-2 
          q22=wpjg(m+2)*wpjg(m)*sq3d8 
          hm(m+4,m)= C2m2*q22 
         end do 
       end if 

       do m=-j,j,2
        do n=m+2,j,2
         hm(m,n)=conjg(hm(n,m))
        end do            
       end do 
!      do m=-j,j,2                                                      
!       write(6,'(8g12.4)') (hm(m,n),n=-j,j,2)
!      end do 
       do m=1,j+1
        do n=1,j+1
         hamg(m,n)=hm(-j-2+2*n,-j-2+2*m)
        end do            
       end do           

!      direct product of heij x hgij       -------------------------------------
!       (hg(ij)*)*dee(lm) -he(lm)*dgg(ij)      ijlm -> pq [p,q=1,...,(je+1)*(jg+1)] 
!       iq(l,i)=1,2,...,
!      the -conjg  of the superoperator HX is calculated

       do i=1,jg+1
        do j=1,jg+1
         do l=1,je+1
          do m=1,je+1
             HXs(iq(l,i),iq(m,j),nstate)= &
                      -hamg(i,j)*dee(l,m) +conjg(hame(l,m))*dgg(i,j)
          end do
         end do
        end do
       end do
      
      if(nstate.eq.1) then
!      shift12 added to state number nstate=1
       do i=1,jge
        HXs(i,i,1)= HXs(i,i,1)+shift12
       end do
       goto 1111
      end if

     do k=1,ks
      do n=1,ks     
       do i=1,jg+1
        do j=1,jg+1
         do l=1,je+1
          do m=1,je+1
           HXab(iab(l,i,k),iab(m,j,n))=HXs(iq(l,i),iq(m,j),k)*dab(k,n)+  &
                                       wab(k,n)*dgg(i,j)*dee(l,m)
          end do
         end do
        end do
       end do
      end do
     end do

!     print*,'aimag HXab'
!     do k=1,2
!      do l=1,je+1
!      do i=1,jg+1
!print'(16f8.2)',(((aimag(HXab(iab(l,i,k),iab(ml,ji,n))),ji=1,jg+1),ml=1,je+1),n=1,2)
!      end do
!      end do
!     end do
!     AA=HXab
!print*,'AA'
!print'(2f10.3,4x,2f10.3)', AA(3,3), AA(3,11)
!print'(2f10.3,4x,2f10.3)', AA(11,3),AA(11,11)
!print*,'AA2'
!print'(2f10.3,4x,2f10.3)', AA(6,6), AA(6,14)
!print'(2f10.3,4x,2f10.3)', AA(14,6),AA(14,14)     
       call jacCmplx16(jge*ks,DOUT,HXab,VL,VR,nrot) 
       do i=1,jge*ks 
          Eagd(i)=HXab(i,i)
       end do 

       
!BB=matmul(VL,AA); CC=matmul(BB,VR)
!print*,'CC'
!print'(2f10.3,4x,2f10.3)', CC(3,3), CC(3,11)
!print'(2f10.3,4x,2f10.3)', CC(11,3),CC(11,11)
!print*,'CC2'
!print'(2f10.3,4x,2f10.3)', CC(6,6), CC(6,14)
!print'(2f10.3,4x,2f10.3)', CC(14,6),CC(14,14)
!print*,'VL'
!print'(2f10.3,4x,2f10.3)', VL(3,3), VL(3,11)
!print'(2f10.3,4x,2f10.3)', VL(11,3),VL(11,11)
!print*,'VR'
!print'(2f10.3,4x,2f10.3)', VR(3,3), VR(3,11)
!print'(2f10.3,4x,2f10.3)', VR(11,3),VR(11,11)

    do m=1,je+1
    do j=1,jg+1
    do n=1,ks
     iabmjn=iab(m,j,n)

     do ml=1,je+1
     do ji=1,jg+1
      iqmj=iq(ml,ji)
      do l=1,je+1
      do i=1,jg+1

!      sum over alpha,beta
       h1c=C0
       do k=1,ks
       do kn=1,ks     
        h1c=h1c+pop(k)*VR(iab(l,i,k),iabmjn)*VL(iabmjn,iab(ml,ji,kn))
       end do
       end do
       RLab(iq(l,i),iqmj,iabmjn)=h1c*Ci
      end do
      end do
     end do
     end do
    end do
    end do
    end do


    VV=C0
    me=je+2; mg=jg+2
    if(itr.eq.1) then
     ! dipole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v1mj=Vje_1_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
          VV(M1,M2,iabmjn)=h1c
       end do
       end do
       end do

      end do
      end do

      !     for calculation of the ideal powder spectrum: VV(M,M,iabmjn)
     if(icase.eq.2) then
       M1=0
       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v1mj=Vje_1_jg(2*ml-me,M1,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
         VV(M1,M1,iabmjn)=h1c
       end do
       end do
       end do
    
       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         VV(0,0,iabmjn)=(VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3.
       end do
       end do
      end do
      end if
    else if(itr.eq.3) then

     ! quadrupole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
          VV(M1,M2,iab(m,j,n))=h1c
       end do
       end do
       end do

      end do
      end do

!     for calculation of the ideal powder spectrum
     if(icase.eq.2) then
      do M1=-2,2,2
       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v2mj=Vje_2_jg(2*ml-me,M1,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
          V2D(M1,iabmjn)=h1c
       end do
       end do
       end do
      end do

      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        VV(0,0,iabmjn)=(V2D(2,iabmjn)+VV(1,1,iabmjn)+V2D(0,iabmjn)+ &
                        VV(-1,-1,iabmjn)+V2D(-2,iabmjn))/5.
      end do
      end do
      end do
     end if
    else if(itr.eq.2) then
     ! mixed  dipole quadrupole transition 
     delta2=r_QUDI**2 
     r_delta2=1./(1.+delta2) 

     ! dipol part 
     do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v1mj=Vje_1_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
         VV(M1,M2,iab(m,j,n))=h1c
       end do
       end do
       end do

     end do
     end do

     ! quadrupole part 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je+1
       do j=1,jg+1
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je+1
         do ji=1,jg+1
          v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je+1
          do i=1,jg+1
           h1c=h1c+Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
         V2(M1,M2,iab(m,j,n))=h1c
       end do
       end do
       end do

      end do
      end do
     
     !mixed part

     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je+1
        do ji=1,jg+1
         v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg)  
         v1mj=Vje_1_jg(2*ml-me,M2,2*ji-mg)  
         do l=1,je+1
         do i=1,jg+1
          h1c=h1c+M1*Vje_2_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj+&
                  M2*Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        VV(M1,M2,iab(m,j,n))=r_delta2*(VV(M1,M2,iab(m,j,n))+    &
                              delta2*M1*M2*V2(M1,M2,iab(m,j,n))-h1c*r_QUDI)
      end do
      end do
      end do
     end do
     end do
     
!     for calculation of the ideal powder spectrum
    if(icase.eq.2) then
     !dipole part
       do M1=-1,1
      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je+1
        do ji=1,jg+1
         v1mj=Vje_1_jg(2*ml-me,M1,2*ji-mg)
         iqmj=iq(ml,ji)           
         do l=1,je+1
         do i=1,jg+1
          h1c=h1c+Vje_1_jg(2*l-me,M1,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
         end do
         end do
        end do
        end do
        VV(M1,M1,iabmjn)=h1c
      end do
      end do
      end do
     end do

     !quadrupole  part
     do M2=-2,2
      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je+1
        do ji=1,jg+1
         v2mj=Vje_2_jg(2*ml-me,M2,2*ji-mg)
         iqmj=iq(ml,ji)           
         do l=1,je+1
         do i=1,jg+1
          h1c=h1c+Vje_2_jg(2*l-me,M2,2*i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        V2D(M2,iabmjn)=h1c
      end do
      end do
      end do
     end do

    if(delta2.ne.0.) then
     do m=1,je+1
      do j=1,jg+1
      do n=1,ks
       iabmjn=iab(m,j,n)
       VV(0,0,iabmjn)=r_delta2*((VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3+&
                        delta2*(V2D(-2,iabmjn)+V2D(-1,iabmjn)+V2D(0,iabmjn)+ &
                                 V2D(1,iabmjn)+V2D(2,iabmjn))/5.)

      end do
      end do
     end do
    else
      do m=1,je+1
      do j=1,jg+1
      do n=1,ks
       iabmjn=iab(m,j,n)
       VV(0,0,iabmjn)=(VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3.
      end do
      end do
      end do
     end if
   
     end if
    end if

   return 
   END                                           
                                                                        
    subroutine intJgJeRELAX2(itr,icase,r_QUDI,amueg,amuee,QgdQe,cTms,je,jg,jge,  &
                     shift12,pop1,fsx1,fsx2,w12,hv1,efg1,hv2,efg2,Eagd,VV)
!      ---------------integral spin -----------------------------       
     implicit none 
     integer, parameter:: ks=2             ! 2 states
     integer, intent(in):: itr,icase,jg,je,jge
     real,    intent(in):: r_QUDI,amueg,amuee,QgdQe,cTms,shift12,pop1,fsx1,fsx2,w12
     complex, intent(in):: hv1(-1:1),efg1(-2:2),hv2(-1:1),efg2(-2:2)

     complex, intent(out):: Eagd(jge*ks)
     complex, intent(out):: VV(-1:1,-1:1,jge*ks)
     complex, dimension(-1:1,-1:1,jge*ks):: V2
     complex, dimension(-2:2,jge*ks):: V2D

     real,    dimension(-je:je,-1:1,-jg:jg):: Vje_1_jg              
     real,    dimension(-je:je,-2:2,-jg:jg):: Vje_2_jg 
     real,    dimension(-jg:jg):: wpjg
     real,    dimension(-je:je):: wpje
     complex, dimension(-1:1):: hv
     complex, dimension(-2:2):: efgm
                                                                 

    real(kind=8):: DOUT
    complex(kind=8),dimension(jge,jge,ks):: HXs
    complex(kind=8),dimension(jge*ks,jge*ks):: VL,VR,HXab
    real, dimension(2*je+1,2*je+1):: dee
    real, dimension(2*jg+1,2*jg+1):: dgg
    real, dimension(ks,ks)    :: dab
    real, dimension(ks)       :: pop
    complex, dimension(ks,ks):: wab
    complex, dimension(2*je+1,2*je+1) :: hame
    complex, dimension(2*jg+1,2*jg+1) :: hamg
    complex, dimension(jge,jge,jge*ks) :: RLab
    integer, dimension(2*je+1,2*jg+1):: iq
    integer, dimension(2*je+1,2*jg+1,ks):: iab

    integer  i,k,kn,l,m,n,j,jm,me,mg,nrot,M1,M2,ji,ml,nstate,   &
             je2,jg2,iabmjn,iqmj
    complex  :: C20,C2m1,C2m2,H10,H1m1,h1c,v1mj,v2mj 
    real     :: Qjg,Qje,sq2,sq3d8,hmag,h,hi2im1,q20,q21,q22,delta2,r_delta2 
    complex, parameter:: C0=cmplx(0.,0.)

    complex, dimension(:,:), allocatable :: hm  
    jm=je
    if(jg.gt.jm) jm=jg
    allocate(hm(-jm:jm,-jm:jm))
    jg2=2*jg+1; je2=2*je+1

    dOUT=10000.d1
    pop(1)=pop1; pop(2)=1.-pop1
    wab(1,1)=cmplx(0.,-w12);             wab(1,2)=-wab(1,1)
    if(pop1.ge.1.0)then
     wab=0.
    else
     wab(2,1)=cmplx(0.,w12*pop1/pop(2));  wab(2,2)=-wab(2,1)
    end if
!   intensity of site i is multiplied by the Lamb-Mossbauer factor fsxi of site i
!   fxx of the crystal is the same for both sites    
    pop(1)=pop(1)*fsx1;    pop(2)=pop(2)*fsx2;

!      write(6,'(a,6f10.2,/,a,10f8.2)')'  hv=',hv,'efgm=',efgm         
!      magnetic energy                                                  
!      E(B)= - mue*(Bx*Ix+By*Iy+Bz*Iz)/I                                
!              (largest moment is mue - not mue*I(=3/2)-)               
!          = - mue*(Bz*Iz-B(+1)/sq2*I(-) + B(-1)/sq2*I(+))/I            
!      electric energy                                                  
!      E(Vik)= 3/4 eQ /I(2I-1) * Sum;ik Vik*Ii*Ik                       
!              Sum;k q2k*C2-k*(-1)**k                                   
!                                                                       
!      Abragam and Bleaney chapter 17 ,p. 680                           
!              q20=eQ/I(2I-1)*1/2*(3*Iz*Iz-I(I+1))                      
!              q21=-eQ/I(2I-1)*(Iz*(I+) + (I+)*Iz)sqrt(3/8)             
!             q2-1= eQ/I(2I-1)*(Iz*(I-) + (I-)*Iz)sqrt(3/8)             
!              q22= eQ/I(2I-1)*(I+)**2*sqrt(3/8)                        
!             q2-2= eQ/I(2I-1)*(I-)**2*sqrt(3/8)                        
!              C20= 1/2*Vzz                                             
!              C21=-2/3*(Vxz+iVyz)*sqrt(3/8)                            
!             C2-1= 2/3*(Vxz-iVyz)*sqrt(3/8)                            
!              C22= (Vxx-Vyy+2iVxy)*sqrt(3/8)/3                         
!             C2-2= (Vxx-Vyy-2iVxy)*sqrt(3/8)/3                         
!     the potential V= -e/|r-R| of a negative charge -e ( e=|e|)        
                                                                        
!     exited state                                                      
      call symbol3j(.true.,je,jg,Vje_1_jg,Vje_2_jg,wpje,wpjg) 

      sq3d8=sqrt(3./8.) 
      sq2=sqrt(2.) 
      if(QgdQe.gt.9999)then 
        Qjg=1. 
        Qje=0. 
      else 
        Qjg=QgdQe 
        Qje=1. 
      end if 

      dab=0.
      do j=1,ks
       dab(j,j)=1.
      end do
 
      dgg=0.
      do j=1,jg2
       dgg(j,j)=1.
      end do

      dee=0.
      do j=1,je2
       dee(j,j)=1.
      end do

      m=0
      do i=1,jg2
       do l=1,je2
        m=m+1
        iq(l,i)=m
       end do
      end do

     m=0
     do k=1,2
      do i=1,jg2
       do l=1,je2
        m=m+1
        iab(l,i,k)=m
       end do
      end do
     end do
     
!  exited state
      nstate=0
  1111 continue
      nstate=nstate+1
      if(nstate.eq.1) then
       hv=hv1; efgm=efg1
      else if(nstate.eq.2) then
       hv=hv2; efgm=efg2
      end if
      
      j=je 
      hm=C0
      if(j.eq.0) goto 10 
                                                                        
       hmag=amuee/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                        
       hI2IM1=float(j*(2*j-1)) 
       C20=efgm(0)/hI2IM1*Qje 
       C2m1=efgm(-1)/hI2IM1*Qje 
       C2m2=efgm(-2)/hI2IM1*Qje 
       h=float(j*(j+1)) 
       do m=-j,j,1 
        q20=(float(3*m**2)-h)/2. 
        hm(m,m)= C20*q20 + m*H10 
       end do 
                                                                       
       do m=j-1,-j,-1 
        q21=-float(2*m+1)*wpje(m)*sq3d8        !  m+1+m =< m+1   
        hm(m+1,m)= -C2m1*q21 + H1m1*wpje(m)/sq2 
       end do 
                                                                        
       if(j.ge.2) then 
        do m=j-2,-j,-1 
         q22=wpje(m+1)*wpje(m)*sq3d8 
         hm(m+2,m)= C2m2*q22 
        end do 
        end if 
        do m=-j,j,1
         do n=m+1,j,1
          hm(m,n)=conjg(hm(n,m))
         end do            
        end do 
        do m=1,2*j+1
         do n=1,2*j+1
          hame(m,n)=hm(-j-1+n,-j-1+m)
         end do            
        end do                           
   10  continue 
!      groundstate                                                      
       j=jg 
       if(j.eq.0) goto 20 
       hm=C0
                                                                      
       hmag=amueg/float(j)/cTms 
       H10=-hmag*hv(0) 
       H1m1=-hmag*hv(-1) 
                                                                      
        hI2IM1=float(j*(2*j-1)) 
        C20=efgm(0)/hI2IM1*Qjg 
        C2m1=efgm(-1)/hI2IM1*Qjg 
        C2m2=efgm(-2)/hI2IM1*Qjg 
        h=float(j*(j+1)) 
        do m=-j,j,2 
         q20=(float(3*m**2)-h)/2. 
         hm(m,m)= C20*q20 + m*H10 
        end do 
                                                                      
        do m=j-1,-j,-1 
                                                !  m+1= (m+2 + m)/2   
         q21=-float(2*m+1)*wpjg(m)*sq3d8 
         hm(m+1,m)= -C2m1*q21 + H1m1*wpjg(m)/sq2 
        end do 
                                                                      
        if(j.ge.2) then 
         do m=j-2,-j,-1 
          q22=wpjg(m+1)*wpjg(m)*sq3d8 
          hm(m+2,m)= C2m2*q22 
         end do 
        end if 
        do m=-j,j,1
         do n=m+1,j,1
          hm(m,n)=conjg(hm(n,m))
         end do            
        end do       
        do m=1,2*j+1
         do n=1,2*j+1
          hamg(m,n)=hm(-j-1+n,-j-1+m)
         end do            
        end do           
   20  continue 

!      direct product of heij x hgij       -------------------------------------
!       (hg(ij)*)*dee(lm) -he(lm)*dgg(ij)      ijlm -> pq [p,q=1,...,(je+1)*(jg+1)] 
!       iq(l,i)=1,2,...,
!      the -conjg  of the superoperator HX is calculated

       do i=1,jg2
        do j=1,jg2
         do l=1,je2
          do m=1,je2
           HXs(iq(l,i),iq(m,j),nstate)= -hamg(i,j)*dee(l,m) +conjg(hame(l,m))*dgg(i,j)
          end do
         end do
        end do
       end do
      
      if(nstate.eq.1) then
!      shift12 added to state number nstate=1
       do i=1,jge
        HXs(i,i,1)= HXs(i,i,1)+shift12
       end do
       goto 1111
      end if

      do k=1,ks
      do n=1,ks     
       do i=1,jg2
       do j=1,jg2
        do l=1,je2
        do m=1,je2
         HXab(iab(l,i,k),iab(m,j,n))=HXs(iq(l,i),iq(m,j),k)*dab(k,n)+  &
                                       wab(k,n)*dgg(i,j)*dee(l,m)
        end do
        end do
       end do
       end do
      end do
      end do

!     print*,'HXab'
!     do k=1,2
!      do l=1,je+1
!      do i=1,jg+1
!print'(16f8.2)',(((real(HXab(iab(l,i,k),iab(ml,ji,n))),ji=1,jg+1),ml=1,je+1),n=1,2)
!      end do
!      end do
!     end do

     call jacCmplx16(jge*ks,DOUT,HXab,VL,VR,nrot) 
     do i=1,jge*ks 
      Eagd(i)=HXab(i,i)
     end do 

    do m=1,je2
    do j=1,jg2
    do n=1,ks
     iabmjn=iab(m,j,n)

     do ml=1,je2
     do ji=1,jg2
      iqmj=iq(ml,ji)
      do l=1,je2
      do i=1,jg2
!      sum over alpha,beta
       h1c=C0
       do k=1,ks
       do kn=1,ks     
        h1c=h1c+pop(k)*VR(iab(l,i,k),iabmjn)*VL(iabmjn,iab(ml,ji,kn))
       end do
       end do
       RLab(iq(l,i),iqmj,iabmjn)=h1c
      end do
      end do
     end do
     end do
    end do
    end do
    end do

    VV=C0
    me=je+1; mg=jg+1
    if(itr.eq.1) then
     ! dipole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v1mj=Vje_1_jg(ml-me,M2,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
          VV(M1,M2,iabmjn)=h1c
       end do
       end do
       end do
      end do
      end do
!     for calculation of the ideal powder spectrum: VV(M,M,iabmjn)
!     stored in VV(0,0,iabmjn)
     if(icase.eq.2) then
      M1=0
       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)

         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v1mj=Vje_1_jg(ml-me,M1,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
          end do
          end do
         end do
         end do
          VV(M1,M1,iabmjn)=h1c
       end do
       end do
       end do
       ! trace/(2L+1) is the powder intensity (f isotropic !!)
       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)
         VV(0,0,iabmjn)=(VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3.
       end do
       end do
       end do
      end if
    else if(itr.eq.3) then
     ! quadrupole transition 
      do M1=-1,1,2
      do M2=-1,1,2

       do m=1,je2
       do j=1,jg2
       do n=1,ks
         iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v2mj=Vje_2_jg(ml-me,M2,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
         VV(M1,M2,iabmjn)=h1c
       end do
       end do
       end do
      end do
      end do

!     for calculation of the ideal powder spectrum
    if(icase.eq.2) then
     do M1=-2,2,2
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
         h1c=C0
         do ml=1,je2
         do ji=1,jg2
          v2mj=Vje_2_jg(ml-me,M2,ji-mg) 
          iqmj=iq(ml,ji)
          do l=1,je2
          do i=1,jg2
           h1c=h1c+Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
          end do
          end do
         end do
         end do
         V2D(M1,iabmjn)=h1c
       end do
       end do
       end do
      end do

      ! trace/(2L+1) is the powder intensity (f isotropic !!)
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        VV(0,0,iabmjn)=(V2D(2,iabmjn)+VV(1,1,iabmjn)+V2D(0,iabmjn)+ &
                        VV(-1,-1,iabmjn)+V2D(-2,iabmjn))/5.
      end do
      end do
      end do
     end if
    else if(itr.eq.2) then
     ! mixed  dipole quadrupole transition 
     delta2=r_QUDI**2 
     r_delta2=1./(1.+delta2) 

     ! dipol part 
     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v1mj=Vje_1_jg(ml-me,M2,ji-mg)
         iqmj=iq(ml,ji) 
         do l=1,je2
         do i=1,jg2
           h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
         end do
         end do
        end do
        end do
        VV(M1,M2,iab(m,j,n))=h1c
      end do
      end do
      end do
     end do
     end do

     ! quadrupole part 
     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v2mj=Vje_2_jg(ml-me,M2,ji-mg) 
         iqmj=iq(ml,ji)
         do l=1,je2
         do i=1,jg2
          h1c=h1c+Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
         V2(M1,M2,iab(m,j,n))=h1c
      end do
      end do
      end do

     end do
     end do

     !mixed part
     do M1=-1,1,2
     do M2=-1,1,2

      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v2mj=Vje_2_jg(ml-me,M2,ji-mg)  
         v1mj=Vje_1_jg(ml-me,M2,ji-mg)  
         do l=1,je2
         do i=1,jg2
          h1c=h1c+M1*Vje_2_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj+ &
                  M2*Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        VV(M1,M2,iab(m,j,n))=r_delta2*(VV(M1,M2,iab(m,j,n))+    &
                              delta2*M1*M2*V2(M1,M2,iab(m,j,n))-h1c*r_QUDI)
      end do
      end do
      end do
     end do
     end do

!    for calculation of the ideal powder spectrum
    if(icase.eq.2) then
     !dipole part
     M1=0
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v1mj=Vje_1_jg(ml-me,M1,ji-mg)  
         do l=1,je2
         do i=1,jg2
            h1c=h1c+Vje_1_jg(l-me,M1,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v1mj
         end do
         end do
        end do
        end do
        VV(0,0,iabmjn)=h1c
      end do
      end do
      end do

     !quadrupole  part
     do M2=-2,2
      do m=1,je2
      do j=1,jg2
      do n=1,ks
        iabmjn=iab(m,j,n)
        h1c=C0
        do ml=1,je2
        do ji=1,jg2
         v2mj=Vje_2_jg(ml-me,M2,ji-mg)  
         do l=1,je2
         do i=1,jg2
          h1c=h1c+Vje_2_jg(l-me,M2,i-mg)*RLab(iq(l,i),iqmj,iabmjn)*v2mj
         end do
         end do
        end do
        end do
        V2D(M2,iabmjn)=h1c
      end do
      end do
      end do
     end do

      do m=1,je2
      do j=1,jg2
      do n=1,ks
       iabmjn=iab(m,j,n)
       VV(0,0,iabmjn)=r_delta2*((VV(-1,-1,iabmjn)+VV(0,0,iabmjn)+VV(1,1,iabmjn))/3+&
                                 delta2*(V2D(-2,iabmjn)+V2D(-1,iabmjn)+V2D(0,iabmjn)+ &
                                 V2D(1,iabmjn)+V2D(2,iabmjn))/5.)
      end do
      end do
      end do
     end if
    end if

   return 
   END                                           

